<template>
  <GenericLayout>
    <template #header>
      <Header
        back-button
        :title="pageTitle"
        :badge-content="pageSubTitle"
      />
    </template>

    <template #page-content>
      <div>
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <template v-if="loading">
          <div
            class="column flex-center"
          >
            <q-spinner-dots
              color="primary"
              size="40px"
            />
          </div>
        </template>

        <template v-else-if="plotPlantVariety || isNew">
          <PlotCropEditForm
            :initial-plant-species="plantSpecies"
            :initial-plant-variety="plantVariety"
            :initial-irrigation-method="irrigationMethod"
            :initial-percentage="percentage"
            :max-percentage="maxPercentage"
            :initial-crop-yield="cropYield"
            :existing-plot-plant-varieties="plotPlantVarieties"
            @on-save="onSave"
            @on-cancel="onCancel"
          />

          <template v-if="plotPlantVariety">
            <div
              class="row justify-end q-mt-lg"
              v-if="plotPlantVarietyCanBeDeleted"
            >
              <q-btn
                flat
                text-color="red"
                :disable="!plotPlantVariety"
                :loading="deleting"
                @click="onDelete"
              >
                <translate>Remove this crop</translate>
              </q-btn>
            </div>
          </template>
        </template>

        <template v-else-if="!isNew">
          <q-card :square="!isDesktopPlatform">
            <q-card-section>
              <span class="text-subtitle1 text-dark">
                <translate>No crop found</translate>
              </span>
            </q-card-section>
          </q-card>
        </template>
      </div>
    </template>
    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { getPlotAvailableAreaPercentage } from 'src/services/plot/plotFormatting'
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import PlotCropEditForm from 'src/pages/holding-campaign/plot/components/PlotCropEditForm'
import queryPlotPlantVarietiesByPlot from 'src/pages/holding-campaign/plot/graphql/queryPlotPlantVarietiesByPlot'
import mutationDeletePlotPlantVariety from 'src/pages/holding-campaign/plot/graphql/mutationDeletePlotPlantVariety'
import mutationUpdatePlotPlantVariety from 'src/pages/holding-campaign/plot/graphql/mutationUpdatePlotPlantVariety'
import mutationInsertPlotPlantVariety from 'src/pages/holding-campaign/plot/graphql/mutationInsertPlotPlantVariety'
import featureFlags from 'src/services/feature-flags'

export default {
  name: 'PlotCropEditPage',
  mixins: [
    PlatformMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    PlotCropEditForm
  },
  data () {
    return {
      deleting: false
    }
  },
  computed: {
    pageTitle () {
      return this.plotPlantVarietyName
    },
    pageSubTitle () {
      return this.$store.state.fastplatform.holdingCampaign.campaign.name
    },
    loading () {
      return !this.isNew && !this.plotPlantVariety && this.$apollo.queries.plotPlantVarieties.loading
    },
    plotId () {
      return Number(this.$route.params.idPlot)
    },
    plotPlantVarietyId () {
      return Number(this.$route.params.idCrop)
    },
    isNew () {
      return !this.plotPlantVarietyId
    },
    plotPlantVariety () {
      if (this.isNew || !this.plotPlantVarieties?.length) {
        return null
      }
      return this.plotPlantVarieties.find(plotPlantVariety => plotPlantVariety.id === this.plotPlantVarietyId)
    },
    plotPlantVarietyName () {
      if (this.isNew) {
        return this.$gettext('Assign crop')
      } else if (this.plotPlantVariety?.plantVariety?.name?.length > 1) {
        return this.plotPlantVariety.plantVariety.name
      } else if (this.plotPlantVariety) {
        return this.plotPlantVariety.plantVariety.plantSpecies.name
      } else {
        return '...'
      }
    },
    plantVariety () {
      return this.plotPlantVariety?.plantVariety
    },
    plantSpecies () {
      return this.plantVariety?.plantSpecies
    },
    irrigationMethod () {
      return this.plotPlantVariety?.irrigationMethod
    },
    percentage () {
      if (this.isNew || !this.plotPlantVariety?.percentage) {
        const availablePct = getPlotAvailableAreaPercentage(this.plotPlantVarieties)
        return availablePct ?? 100
      } else {
        return this.plotPlantVariety?.percentage
      }
    },
    maxPercentage () {
      return this.isNew ? this.percentage : getPlotAvailableAreaPercentage(this.plotPlantVarieties, this.plotPlantVarietyId)
    },
    cropYield () {
      return this.plotPlantVariety?.cropYield
    },
    plotPlantVarietyCanBeDeleted () {
      return featureFlags.plotPlantVarietyCanBeDeleted()
    }
  },
  apollo: {
    plotPlantVarieties: {
      query: queryPlotPlantVarietiesByPlot,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.plotId
        }
      }
    }
  },
  methods: {
    onSave (plantVarietyId, irrigationMethodId, percentage, cropYield) {
      if (this.isNew) {
        this.onCreate(plantVarietyId, irrigationMethodId, percentage, cropYield)
      } else {
        this.onUpdate(plantVarietyId, irrigationMethodId, percentage, cropYield)
      }
    },
    onCreate (plantVarietyId, irrigationMethodId, percentage, cropYield) {
      this.$apollo.mutate({
        mutation: mutationInsertPlotPlantVariety,
        variables: {
          plotId: this.plotId,
          plantVarietyId,
          irrigationMethodId,
          percentage,
          cropYield
        }
      }).then(() => {
        this.$q.notify({
          message: this.$gettext('The crop was successfully assigned to the plot.'),
          color: 'green'
        })
        this.$router.back()
      }).catch(e => {
        console.error('Could not assign crop', e)
        this.$q.notify({
          message: this.$gettext('There was an error while assigning the crop.'),
          color: 'red'
        })
      })
    },
    onUpdate (plantVarietyId, irrigationMethodId, percentage, cropYield) {
      this.$apollo.mutate({
        mutation: mutationUpdatePlotPlantVariety,
        variables: {
          plotPlantVarietyId: this.plotPlantVarietyId,
          plantVarietyId,
          irrigationMethodId,
          percentage,
          cropYield
        }
      }).then(() => {
        this.$q.notify({
          message: this.$gettext('The crop was successfully updated.'),
          color: 'green'
        })
        this.$router.back()
      }).catch(e => {
        console.error('Could not update crop', e)
        this.$q.notify({
          message: this.$gettext('There was an error while updating the crop.'),
          color: 'red'
        })
      })
    },
    onCancel () {
      this.$router.back()
    },
    onDelete () {
      this.$q.dialog({
        title: this.$gettext('Delete'),
        message: `${this.$gettext('Are you sure you want to remove this crop ?')}`,
        cancel: true,
        color: 'red'
      }).onOk(async () => {
        this.deleting = true
        try {
          await this.$apollo.mutate({
            mutation: mutationDeletePlotPlantVariety,
            variables: {
              plot_plant_variety_id: this.plotPlantVarietyId
            }
          })
          this.$q.notify({
            message: this.$gettext('The crop was successfully removed.'),
            color: 'green'
          })
        } catch (e) {
          this.$q.notify({
            message: this.$gettext('There was an error while removing the crop.'),
            color: 'red'
          })
        } finally {
          this.deleting = false
          this.$router.back()
        }
      })
    }
  }
}
</script>
